"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const Effects = __importStar(require("./effects"));
exports.Effects = Effects;
function useElmish(reducer, initializer) {
    let [state, dispatch] = react_1.useReducer((prevState, action) => {
        let nextStateAndEffect = reducer(prevState[0], action);
        // Same state, no side-effects. Prevents unnecessary rerendering
        if (Object.is(prevState[0], nextStateAndEffect[0]) &&
            nextStateAndEffect[1].length == 0) {
            return prevState;
        }
        else {
            return nextStateAndEffect;
        }
    }, null, _ => initializer());
    react_1.useEffect(() => {
        state[1].forEach((x) => x(dispatch));
    }, [state]);
    return [state[0], dispatch];
}
exports.useElmish = useElmish;
exports.default = useElmish;
